



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>用SysTick做的延时计时器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">用SysTick做的延时计时器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-17 09:34:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>CM3、CM4的内核中都有个24位的SysTick定时器。这两个MCU里边的SysTick大同小异。SysTick的介绍可以参考：（<a href="http://blog.csdn.net/yx_l128125/article/details/7884423" rel="external nofollow noreferrer">来自CSDN博客的参考</a>）或者（<a href="http://wenku.baidu.com/link?url=ifMwFohlpvJnrFoGEPtiOH5H_HEBeXisvxO2kX7AByR2FtIZlZu9Q2sBrtP-uA6ZTMaIV6zwjtYXKpejKuyFIEbStLYryNtAsk6h6CYfHPC" rel="external nofollow noreferrer">来自百度文库的参考</a>）或者参考《CM3权威指南》这个书。在ST的参考手册中没有SysTick的介绍。因为它是属于内核的东西。</p>
<p>这个实验是使用Systick中断方式做延时定时器。主要目的是熟悉下SysTick的使用。</p>
<p>首先，定义个延时函数，目的是计数</p>
<blockquote><div>
<pre class="prettyprint linenums">void Delay(__IO uint32_t nTime)<br />
{<br />
  TimingDelay = nTime;<br />
  while(TimingDelay != 0);<br />
}

void TimingDelay_Decrement(void)<br />
{<br />
  if (TimingDelay != 0x00)<br />
  {<br />
    TimingDelay--;<br />
  }<br />
}</pre>
</div></blockquote>
<p>其中TimingDelay_Decrement是供SysTick的中断响应函数调用的。每次调用就将TimingDelay减少1，知道0为止.</p>
<p>Delay函数就是一直等着TimingDelay 减到0.</p>
<p>然后配置SysTick定时器。使用系统函数</p>
<blockquote><p>SysTick_Config(SystemCoreClock/1000)；</p></blockquote>
<p>这个函数打开了SysTick的中断，同时也设置了Systick的重装载寄存器。SystemCoreClock/1000既是系通时钟频率的千分之一。也就是说没每秒钟，Systick寄存器会装满1000次，每次1ms。这就是计时的基础单位了。当重装载寄存器装满时，就会产生Systick中断，之后我们就在中断函数中处理TimingDelay这个标量了。</p>
<p>在文件stm32F4xx_it.c中添加一点Systick的中断处理函数：</p>
<blockquote><div>
<pre class="prettyprint linenums">extern void TimingDelay_Decrement(void);

void SysTick_Handler(void)<br />
{<br />
    TimingDelay_Decrement();<br />
}</pre>
</div></blockquote>
<p>这样，延时函数就配置好了。</p>
<p>在main函数中的用法：</p>
<div>
<pre class="prettyprint linenums">int main(void)<br />
{<br />
。。。。。。

    if(SysTick_Config(SystemCoreClock/1000))<br />
    {<br />
        while(1);<br />
    }    

  while (1)<br />
  {<br />
      Delay(500);<br />
      GPIO_WriteBit(GPIOG,GPIO_Pin_13,Bit_SET);<br />
      Delay(500);<br />
      GPIO_WriteBit(GPIOG,GPIO_Pin_13,Bit_RESET);<br />
  }<br />
}</pre>
</div>
<p>这里的不足之处是你不管使用没有，SysTick总是会反复地产生中断，消耗了一些MCU的资源。当然，如果SysTick用在OS中，作为OS的心跳，这个中断是免不了的。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyj7rgq.html">VendorNPC&period;lua  --随身商人</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw7r5k8.html">font awesome</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnwpkv8.html">uafxcwd&period;lib&lpar;afxmem&period;obj&rpar; &colon; error LNK2005 解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wj5rlq.html">linux 用户、组，修改文件权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd51pe8.html">Redis配置文件解读</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnykd08.html">关于web安全</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x77ow9.html">JQuery好用的日期选择控件 DatePicker</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wyd3lq.html">The 7th Zhejiang Provincial Collegiate Programming Contest-&amp;gt&semi;Problem B：B - Somali Pirates</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg107e8.html">解析Excel文件并把数据存入数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvm5p28.html">leecode第三百四十四题（反转字符串）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25jgzxq.html">linux下Vim文本编辑器的常用快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllvwg0q.html">Android Studio--》Gradle Scripts配置说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o124veq.html">input框限制只能输入正整数、字母、小数、汉字</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ov34e8.html">&lbrack;C&plus;&plus;&rsqb; const与重载</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rxlx28.html">ubuntu16&period;04下安装opencv3&period;4&period;1及其扩展模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5lm5mq.html">搭建Kubernetes服务集群遇到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2y20y9.html">RN返回navigation方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93prkrz8.html">学习 TList 类的实现&lbrack;8&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppldy49.html">SSM-CRUD入门项目&mdash;&mdash;新增与校验</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pldw5q.html">《Angular4从入门到实战》学习笔记</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8mwjvrq.html">第一篇博文，整理一下关于Mac下安装本地LNMP环境的一些坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mwj76q.html">HTML核心元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlk1r68.html">PHP乱码完美解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q22xjxq.html">Ansible-Tower快速入门-7&period;配置实时事件【翻译】</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q22xooq.html">jQuery 遍历 - each&lpar;&rpar; 方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qny5m38.html">Day24&lowbar;多线程第一天</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ejwke9.html">e</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvrj118.html">Github注册账户过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7g2djq.html">js  递归学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlkw3x8.html">PHP的学习--PHP加密</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
